/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 *  strict-local
 * @format
 */

"use strict";
var _extends =
  Object.assign ||
  function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
var _require = require("./js");
const getJsOutput = _require.getJsOutput;

function getSourceMapInfo(module, options) {
  return _extends({}, getJsOutput(module).data, {
    path: module.path,
    source: options.excludeSource ? "" : getModuleSource(module)
  });
}

function getModuleSource(module) {
  if (getJsOutput(module).type === "js/module/asset") {
    return "";
  }

  return module.getSource().toString();
}

module.exports = getSourceMapInfo;
