/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 *  strict-local
 * @format
 */

"use strict";
function _toConsumableArray(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++)
      arr2[i] = arr[i];
    return arr2;
  } else {
    return Array.from(arr);
  }
}

const getSourceMapInfo = require("./helpers/getSourceMapInfo");
var _require = require("./helpers/js");
const isJsModule = _require.isJsModule;
var _require2 = require("metro-source-map");
const fromRawMappings = _require2.fromRawMappings;

function fullSourceMapObject(pre, graph, options) {
  const modules = []
    .concat(
      _toConsumableArray(pre),
      _toConsumableArray(graph.dependencies.values())
    )
    .filter(isJsModule)
    .filter(options.processModuleFilter)
    .map(module =>
      getSourceMapInfo(module, { excludeSource: options.excludeSource })
    );

  return fromRawMappings(modules).toMap(undefined, {
    excludeSource: options.excludeSource
  });
}

module.exports = fullSourceMapObject;
